> ## Documentation Index
> Fetch the complete documentation index at: https://developers.telnyx.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Fetches all Wdr records

> Fetch all Wdr records 



## OpenAPI

````yaml https://telnyx-openapi-ng.s3.us-east-1.amazonaws.com/account-billing/usage-reports.yml get /reports/wdrs
openapi: 3.1.0
info:
  title: Telnyx Usage Reports API
  version: 2.0.0
  description: API for Usage reports.
  contact:
    email: support@telnyx.com
servers:
  - url: https://api.telnyx.com/v2
security:
  - bearerAuth: []
paths:
  /reports/wdrs:
    get:
      tags:
        - WDR Detail Reports
      summary: Fetches all Wdr records
      description: 'Fetch all Wdr records '
      operationId: GetPaginatedWdrs
      parameters:
        - name: start_date
          in: query
          description: Start date
          schema:
            type: string
            example: '2021-05-01T00:00:00Z'
        - name: end_date
          in: query
          description: End date
          schema:
            type: string
            example: '2021-06-01T00:00:00Z'
        - name: id
          in: query
          schema:
            type: string
            description: WDR uuid
            example: e093fbe0-5bde-11eb-ae93-0242ac130002
        - name: mcc
          in: query
          schema:
            type: string
            description: Mobile country code
            example: '204'
        - name: mnc
          in: query
          schema:
            type: string
            description: Mobile network code
            example: '01'
        - name: imsi
          in: query
          schema:
            type: string
            description: International mobile subscriber identity
            example: '123456'
        - name: sim_group_name
          in: query
          schema:
            type: string
            description: Sim group name
            example: sim name
        - name: sim_group_id
          in: query
          schema:
            type: string
            description: Sim group unique identifier
            example: f05a189f-7c46-4531-ac56-1460dc465a42
        - name: sim_card_id
          in: query
          schema:
            type: string
            description: Sim card unique identifier
            example: 877f80a6-e5b2-4687-9a04-88076265720f
        - name: phone_number
          in: query
          schema:
            type: string
            description: Phone number
            example: '+12345678910'
        - name: sort
          in: query
          schema:
            type: array
            items:
              type: string
            description: >-
              Field used to order the data. If no field is specified, default
              value is 'created_at'
            example:
              - created_at
            default:
              - created_at
        - name: page
          in: query
          style: deepObject
          explode: true
          description: >-
            Consolidated page parameter (deepObject style). Originally:
            page[number], page[size]
          schema:
            type: object
            properties:
              number:
                type: integer
                format: int32
                default: 1
                description: Page number
              size:
                type: integer
                format: int32
                default: 20
                description: Size of the page
      responses:
        '200':
          description: Successful
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ExternalWdrGetDetailResponse'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/wireless-public_ErrorResponse'
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Telnyx from 'telnyx';


            const client = new Telnyx({
              apiKey: process.env['TELNYX_API_KEY'], // This is the default and can be omitted
            });


            // Automatically fetches more pages as needed.

            for await (const reportListWdrsResponse of
            client.reports.listWdrs()) {
              console.log(reportListWdrsResponse.id);
            }
        - lang: Python
          source: |-
            import os
            from telnyx import Telnyx

            client = Telnyx(
                api_key=os.environ.get("TELNYX_API_KEY"),  # This is the default and can be omitted
            )
            page = client.reports.list_wdrs()
            page = page.data[0]
            print(page.id)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/team-telnyx/telnyx-go\"\n\t\"github.com/team-telnyx/telnyx-go/option\"\n)\n\nfunc main() {\n\tclient := telnyx.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tpage, err := client.Reports.ListWdrs(context.TODO(), telnyx.ReportListWdrsParams{})\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", page)\n}\n"
        - lang: Java
          source: |-
            package com.telnyx.sdk.example;

            import com.telnyx.sdk.client.TelnyxClient;
            import com.telnyx.sdk.client.okhttp.TelnyxOkHttpClient;
            import com.telnyx.sdk.models.reports.ReportListWdrsPage;
            import com.telnyx.sdk.models.reports.ReportListWdrsParams;

            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    TelnyxClient client = TelnyxOkHttpClient.fromEnv();

                    ReportListWdrsPage page = client.reports().listWdrs();
                }
            }
        - lang: Ruby
          source: |-
            require "telnyx"

            telnyx = Telnyx::Client.new(api_key: "My API Key")

            page = telnyx.reports.list_wdrs

            puts(page)
        - lang: PHP
          source: >-
            <?php


            require_once dirname(__DIR__) . '/vendor/autoload.php';


            use Telnyx\Client;

            use Telnyx\Core\Exceptions\APIException;


            $client = new Client(apiKey: getenv('TELNYX_API_KEY') ?: 'My API
            Key');


            try {
              $page = $client->reports->listWdrs(
                id: 'e093fbe0-5bde-11eb-ae93-0242ac130002',
                endDate: '2021-06-01T00:00:00Z',
                imsi: '123456',
                mcc: '204',
                mnc: '01',
                pageNumber: 0,
                pageSize: 0,
                phoneNumber: '+12345678910',
                simCardID: '877f80a6-e5b2-4687-9a04-88076265720f',
                simGroupID: 'f05a189f-7c46-4531-ac56-1460dc465a42',
                simGroupName: 'sim name',
                sort: ['created_at'],
                startDate: '2021-05-01T00:00:00Z',
              );

              var_dump($page);
            } catch (APIException $e) {
              echo $e->getMessage();
            }
        - lang: CLI
          source: |-
            telnyx reports list-wdrs \
              --api-key 'My API Key'
components:
  schemas:
    ExternalWdrGetDetailResponse:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/ExternalWdrDetailRecordDto'
        meta:
          $ref: '#/components/schemas/wireless-public_PaginationMeta'
    wireless-public_ErrorResponse:
      type: object
      properties:
        errors:
          type: array
          items:
            $ref: '#/components/schemas/wireless-public_Error'
    ExternalWdrDetailRecordDto:
      type: object
      properties:
        id:
          type: string
          description: WDR id
          example: 3ca7bd3d-7d82-4e07-9df4-009123068320
        created_at:
          type: string
          description: Record created time
          format: date-time
          example: '2020-07-01T00:00:00-06:00'
        cost:
          $ref: '#/components/schemas/WirelessCost'
        mcc:
          type: string
          description: Mobile country code.
          example: '204'
        mnc:
          type: string
          description: Mobile network code.
          example: '01'
        downlink_data:
          $ref: '#/components/schemas/DownlinkData'
        duration_seconds:
          type: number
          description: Session duration in seconds.
          example: 1
        imsi:
          type: string
          description: International mobile subscriber identity.
          example: '123'
        rate:
          $ref: '#/components/schemas/WirelessRate'
        sim_group_name:
          type: string
          description: Defined sim group name
          example: sim name
        sim_group_id:
          type: string
          description: Sim group unique identifier
          example: f05a189f-7c46-4531-ac56-1460dc465a42
        sim_card_id:
          type: string
          description: Sim card unique identifier
          example: 877f80a6-e5b2-4687-9a04-88076265720f
        phone_number:
          type: string
          description: Phone number
          example: '+12345678910'
        uplink_data:
          $ref: '#/components/schemas/UplinkData'
        record_type:
          type: string
          example: wdr
    wireless-public_PaginationMeta:
      type: object
      properties:
        total_pages:
          type: integer
          format: int32
          example: 3
        total_results:
          type: integer
          format: int32
          example: 55
        page_number:
          type: integer
          format: int32
          example: 2
        page_size:
          type: integer
          format: int32
          example: 25
    wireless-public_Error:
      type: object
      properties:
        code:
          type: string
          example: '10011'
        title:
          type: string
          example: Bad Request
        detail:
          type: string
          example: Invalid parameter value
    WirelessCost:
      type: object
      properties:
        amount:
          type: string
          description: Final cost. Cost is calculated as rate * unit
          example: '0.1'
        currency:
          type: string
          description: Currency of the rate and cost
          example: USD
          enum:
            - AUD
            - CAD
            - EUR
            - GBP
            - USD
    DownlinkData:
      type: object
      properties:
        amount:
          type: number
          description: Downlink data
          example: 1
        unit:
          description: Transmission unit
          type: string
          enum:
            - B
            - KB
            - MB
          default: MB
    WirelessRate:
      type: object
      properties:
        amount:
          type: string
          description: Rate from which cost is calculated
          example: '0.1'
        currency:
          type: string
          description: Currency of the rate and cost
          example: USD
          enum:
            - AUD
            - CAD
            - EUR
            - GBP
            - USD
    UplinkData:
      type: object
      properties:
        amount:
          type: number
          description: Uplink data
          example: 1
        unit:
          description: Transmission unit
          type: string
          enum:
            - B
            - KB
            - MB
          default: MB
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http

````